<script>
	import Multiselect from '@vueform/multiselect'
	import '@vueform/multiselect/themes/default.css'
	import { inject } from 'vue';
	
	export default {
	  components: {
	    Multiselect,
	  },
	  setup(props) {
	  const csrf = inject('csrf');
	
	  return {
	    csrf,
	  };
	},
	  data() {
	
	    return {
        ID: this.variables.user?.id,
        correo: this.variables.user?.email,
        nombres:this.variables.user?.nombres,
        primerApellido:this.variables.user?.primerApellido,
        segundoApellido:this.variables.user?.segundoApellido,

        TiposInstitucionesSeleccionados: [],

        institucionesDependencias: this.variables && this.variables.institucionesDependencias
	      ? this.variables.institucionesDependencias.map(item => item)
	      : [],

        rol: this.variables.user.rol.id,
	      
	      roles: this.variables && this.variables.roles
	      ? this.variables.roles.map(item => item)
	      : [],

        InstitucionesIds: [],
        sancionesNombre:[],


        edicionHabilitadaDatosPersonales: false,
        camposDeshabilitadosDatosPersonales: true,
        
	
	      
	    }
	  },
	  props: {
	    variables: Object,
	},

  
	mounted(){
	  const csrf = inject('csrf');
	  console.log(csrf);


	  
	},

  created(){

    this.TiposInstitucionesSeleccionados = this.variables.user.institucionesDependencias.map(institucion => institucion.nombre);


  },

  watch:{
    TiposInstitucionesSeleccionados: function(newValue) {

// Obtener los IDs de las opciones seleccionadas
const selectedIds = newValue.map(option => {
  const selectedOption = this.institucionesDependencias.find(sancion => sancion.nombre === option);
  return selectedOption ? selectedOption.id : null;
});


const selectedNombres = newValue.map(option => {
const selectedOption = this.institucionesDependencias.find(sancion => sancion.nombre === option);
return selectedOption ? selectedOption.valor : null;
});


this.sancionesNombre = selectedNombres
this.InstitucionesIds = selectedIds;
console.log(this.InstitucionesIds)
},
  },


	methods: {
	  
    botonEditarDatosPersonales(){
      this.edicionHabilitadaDatosPersonales = true;
      this.camposDeshabilitadosDatosPersonales = false;
    },

    botonRestablecerContraseña(){

      swal({
        title: "¿Seguro deseas restablecer la contraseña?",
        text: "Una vez restablecida no se podra volver a recuperar",
        icon: "warning",
        buttons: true,
        dangerMode: true,
        buttons: ["Cancelar", "restablecer"],
        confirmButtonClass: "btn-warning",
        cancelButtonClass: "btn-danger"
      })
        .then((willDelete) => {
          if (willDelete) {
            axios.get(route('usuarios.reset.password' , this.ID))
              .then(response => {
                console.log(response);
                swal("Ha sido restablecida exitosamente, su nueva contraseña es " + response.data.data, {
                  icon: "success",
                  buttons: true
                });
              })
              .catch(error => {
                console.error(error);
                swal("Cancelado", {
                  icon: "error"
                });
              });
          } else {
            console.log('Salvado')
            swal("Cancelado", {
              icon: "error"
            });
          }
        });

    },

    cancelarEdicion() {

      this.correo =  this.variables.user?.email;
        this.nombres = this.variables.user?.nombres;
        this.primerApellido = this.variables.user?.primerApellido;
        this.segundoApellido = this.variables.user?.segundoApellido;
        this.rol = this.variables.user.rol.id;
        this.TiposInstitucionesSeleccionados = this.variables.user.institucionesDependencias.map(institucion => institucion.nombre);

 

    this.camposDeshabilitadosDatosPersonales = true;
    this.edicionHabilitadaDatosPersonales = false;
  },
  
	},

   


	}
	
</script>   


<template>
  <div class="main-content">
    <div class="page-content">
      <div class="container-fluid">
        <!-- start page title -->
        <div class="row">
          <div class="col-12">
            <div class="page-title-box d-sm-flex align-items-center justify-content-between">
              <h4 class="mb-sm-0 font-size-18">Detalles del usuario</h4>
            </div>
          </div>
        </div>
        <!-- end page title -->

       
        
         
            <!-- Contenido de la primera pestaña -->
            <div class="card">
              <div class="card-body">
                <form method="POST" :action="route('usuarios.edit')">
                  <h4 class="card-title mb-4">Datos personales</h4>
                  <div class="row">
                    <div class="col-md-4" hidden>
                      <div class="mb-3">
                        <label for="validationCustom03" class="form-label">ID</label>
                        <div class="input-group">
                          <input name="id" type="text" class="form-control" placeholder="ID" v-model="ID"/>
                          </div>
                        </div>
                    </div>
                    <div class="col-md-4">
                      <div class="mb-3">
                        <label for="validationCustom02" class="form-label">Nombre</label>
                        <input name="nombres" type="text"  class="form-control" v-model="nombres" :disabled="camposDeshabilitadosDatosPersonales">
                        <div class="valid-feedback">
                          ¡Se ve bien!
                        </div>
                      </div>
                    </div>

                    <div class="col-md-4">
                      <div class="mb-3">
                        <label for="validationCustom02" class="form-label">Primer apellido</label>
                        <input name="primerApellido" type="text"  v-model="primerApellido" class="form-control"  :disabled="camposDeshabilitadosDatosPersonales">
                        <div class="valid-feedback">
                          ¡Se ve bien!
                        </div>
                      </div>
                    </div>
                   
                    <div class="col-md-4">
                      <div class="mb-3">
                        <label for="validationCustom02" class="form-label">Segundo apellido</label>
                        <input name="segundoApellido" type="text"  v-model="segundoApellido" class="form-control"  :disabled="camposDeshabilitadosDatosPersonales">
                        <div class="valid-feedback">
                          ¡Se ve bien!
                        </div>
                      </div>
                    </div>

                    <div class="col-md-12">
                      <div class="mb-3">
                        <label for="validationCustom11" class="form-label">Rol</label>
                        <select name="roleId" :disabled="camposDeshabilitadosDatosPersonales" v-model="rol" class="form-select"  placeholder="">
                          <option v-for="opcion in roles" :value="opcion.id" :selected="opcion.id === rol">{{ opcion.name }}</option>
                        </select>
                      </div>
                    </div>

                    <div class="col-md-12">
                      <div class="mb-3">
                        <label for="validationCustom14" class="form-label">Institución</label>
                        <Multiselect
                          v-model="TiposInstitucionesSeleccionados"
                          mode="tags"
                          :close-on-select="false"
                          :searchable="true"
                          placeholder="Seleccione una opción"
                          :options="institucionesDependencias.map(option => option.nombre)"
                          class="tipoSancion"
                          :disabled="camposDeshabilitadosDatosPersonales"
                          required
                          :option-label="(option) => TiposInstitucionesSeleccionados.length >= 3 ? `${TiposInstitucionesSeleccionados.length} seleccionados` : option"
                        />

                        <input type="text" hidden name="institucionesDependencias" v-model="InstitucionesIds">

                      </div>
                    </div>

                    
                    <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                      <button class="btn btn-warning" type="button" v-if="!edicionHabilitadaDatosPersonales" @click="botonEditarDatosPersonales">Editar</button>
                      <button class="btn btn-warning" type="button" v-if="edicionHabilitadaDatosPersonales" @click="botonRestablecerContraseña">Reestablecer contraseña</button>
                      <button class="btn btn-danger" type="button" v-if="edicionHabilitadaDatosPersonales" @click="cancelarEdicion">Cancelar</button>
                      <button class="btn btn-primary" type="submit" v-if="edicionHabilitadaDatosPersonales">Guardar</button>
                    </div>
                    <input type="hidden" name="_token" :value="csrf"/>
                    <input type="hidden" name="_method" value="PUT">
                  </div>
                </form>
               
              </div>
            </div>
          
        
      </div>
    </div>
  </div>
</template>


<style>
	#BuscarCP{
	  width: 80px;
	  height: 34px;
	}
	
	#nuevoSancion{
	  height: 40px;
	}
	
	.btn-primary-check{
	  background-color: #556ee6;
	  color: white;
	}

  .multiselect-tag{
    background: #6045ca;
  }
	
	.multiselect-wrapper {
	    height: 10px;
	    padding: .47rem 1.75rem .47rem .75rem;
	    font-size: .8125rem;
	}
	
	.tipoSancion {
	  height: 150px
	}

 
	
	.dashed-line {
	    border-top: 1px solid  #e6e3e3;
	    margin-top: 20px; /* Ajusta la separación si es necesario */
	}

  .dashed-line-row {
    border-top: 1px solid  #e6e3e3;
    margin-top: 20px;
    width:98%;
}
	
</style>